module LiveIvy
  class IvyLeaf
    def self.reload_components
      @@components = []
      Sketchup.active_model.definitions.each do |d|
        @@components.push(d) if d.name.downcase =~ /ivyleaf/
      end
    end

    def seed
      LiveIvy::IvyTool.seed
    end

    def initialize(node, weight)
      @weight    = weight
      @node      = node
      @component = @@components[(rand(@@components.length.to_f)-1).floor]
      build
    end

    def build
      @root = @node.position_point+@node.sum_vector.transform(-rand)

      @start_direction = @node.adhesion_vector.reverse if @node.adhesion_vector.length > 0.0
      @start_direction = Geom::Vector3d.new(rand-0.5, rand-0.5, -1) unless @start_direction

      @start_vector = (@start_direction+[-0.000001, -0.000001, -0.000001]).normalize.transform(seed.params[:branch][:radius]/(@node.branch.parents+1))
      @start        = @root+@start_vector

      #1. Rotasjon som gjør den ligger paralelt med start_vector
      direction = @node.sum_vector.normalize+@node.adhesion_vector.transform(-1).normalize
      @phi          = Pdn::Vector3d.phi_between(Geom::Vector3d.new(0, 1, 0), direction)

      #2. rotasjon som gjør den ligger vinkelrett på invers adhesion_vector
      thetadir = Geom::Vector3d.new(0,0,1) if @start_direction.z < 0
      thetadir = @node.sum_vector unless thetadir
      @theta        = Pdn::Vector3d.theta_between(Geom::Vector3d.new(0, 1, 0), thetadir)

    end

    def component
      @component
    end

    def start
      @start
    end

    def phi_rotation
      Geom::Transformation.rotation @start, [0, 0, 1], @phi
    end

    def theta_rotation
      axis = @start_vector.cross(@node.sum_vector)
      Geom::Transformation.rotation @start, axis, @theta
    end
    def node_rotation

    end
    def skew_rotation
      Geom::Transformation.rotation @start, @start_vector, Math::PI/4*rand-Math::PI/8
    end

  end
end